const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payments = sequelize.define(
    'payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

method: {
        type: DataTypes.ENUM,
      
      

        values: [

"cash",


"transfer",


"va",


"qris",


"lainnya"

        ],

      },

reference_number: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"success",


"failed",


"refunded"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.payments.belongsTo(db.billing_items, {
      as: 'billing_item',
      foreignKey: {
        name: 'billing_itemId',
      },
      constraints: false,
    });

    db.payments.belongsTo(db.users, {
      as: 'paid_by_user',
      foreignKey: {
        name: 'paid_by_userId',
      },
      constraints: false,
    });

    db.payments.belongsTo(db.schools, {
      as: 'schools',
      foreignKey: {
        name: 'schoolsId',
      },
      constraints: false,
    });



    db.payments.hasMany(db.file, {
      as: 'proof',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.payments.getTableName(),
        belongsToColumn: 'proof',
      },
    });


    db.payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payments;
};


